local off = W_OPTION:Name('Off')
local gimmick = {
    [PLAYER_1] = W_PLAYER:ReadPref(PLAYER_1, 'GimmickName', off),
    [PLAYER_2] = W_PLAYER:ReadPref(PLAYER_2, 'GimmickName', off),
}
local alreadyLoadGimmick = ''
local function GimmickActor(pn)
    if not W_PLAYER:IsEnabled(pn) or not gimmick or gimmick[pn] == off then
        return Def.ActorFrame({})
    end
    -- P1とP2が同じ設定の場合
    if alreadyLoadGimmick == gimmick[pn] then
        return Def.ActorFrame({})
    end
    alreadyLoadGimmick = gimmick[pn]
    local luaString = W:LuaD(THEME:GetCurrentThemeDirectory()..'Other/Gimmick/'..string.lower(gimmick[pn]))
    if luaString then
        local gimmickLua = luaString()
        if gimmickLua.Enable() then
            return gimmickLua.Actor[pn]
        end
    end
    return Def.ActorFrame({})
end

local flare = {[PLAYER_1] = 'Normal', [PLAYER_2] = 'Normal'}
if not GAMESTATE:IsDemonstration() then
    for _,pn in pairs(PlayerNumber) do
        if W_PLAYER:IsEnabled(pn) then
            flare[pn] = W_PLAYER:ReadPref(pn, 'GuageType') or 'Normal'
            -- OF5のバグ対策(pre043-a35)
            if W:IsOFV() then
                local chartKey = GAMESTATE:GetCurrentSteps(pn):GetChartKey()
            end
        end
    end
end

local player
local life
return Def.ActorFrame({
    OffCommand = function(self)
        self:sleep(2)
    end,
    LoadActor(THEME:GetPathG('', 'ScreenGameplay/_parts/frame/life/flare'), flare),

    -- スコア計算式の設定
    YA_SCORE:Actor(W_OPTION:ReadPref('ScoreMode')),
    -- リアルタイムスクロール（ハイスピード・Reverse）変更
    YA_SCROLL:Actor(),

    -- ギミックモード
    GimmickActor(PLAYER_1),
    GimmickActor(PLAYER_2),
    
    -- 各パーツ
    LoadActor(THEME:GetPathG('', 'ScreenGameplay/decorations'))..{
        Name = 'Overlay',
    },
    
    -- ハイスピードとスクロール方向の変更が行われたときに表示
    LoadActor(THEME:GetPathG('', 'ScreenGameplay/_parts/player information'), PLAYER_1),
    LoadActor(THEME:GetPathG('', 'ScreenGameplay/_parts/player information'), PLAYER_2),
    -- ライト
    --LoadActor(W:Object('side light')),

    -- 情報更新用
    LoadActor('update'),

    -- -- Cut2
    -- Def.Actor({
    --     OnCommand = function(self)
    --         local player = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
    --         local newNotes = {}
    --         for _,v in pairs(player:GetNoteData()) do
    --             local beat = v[1] * 2
    --             if math.floor(beat) == beat then
    --                 newNotes[#newNotes+1] = v
    --             end
    --         end
    --         player:SetNoteDataFromLua(newNotes)
    --     end,
    -- }),
    -- Def.Quad({
    --     OnCommand = function(self)
    --         self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
    --         self:diffusealpha(0.5)
    --         self:vertalign(top)
    --         self.posY = SCREEN_BOTTOM
    --         self:xy(SCREEN_CENTER_X, self.posY)
    --     end,
    --     CodeCommand = function(self, params)
    --         if params.Name == 'MenuUpTest' then
    --             _SYS('これはメニュー専用の上キー')
    --             self.posY = (self.posY) - 80
    --             if self.posY < 0 then self.posY = SCREEN_BOTTOM end
    --             self:y(self.posY)
    --         end
    --         if params.Name == 'FootUpTest' then
    --             _SYS('これはフットパネルの上キー')
    --         end
    --     end,
    -- }),
})
