local flarePn = ...
local off = 'Normal'

local ff = {[PLAYER_1] = true, [PLAYER_2] = true}   -- フローティング
local plLevel = {[PLAYER_1] = 10, [PLAYER_2] = 10}  -- レベル
local pl = {[PLAYER_1] = nil, [PLAYER_2] = nil}
local lf = {[PLAYER_1] = 10000, [PLAYER_2] = 10000}

local mapFlareLevel = {
    off = 0,
    ['Floating'] = 10,
    ['Flare 1'] = 1,
    ['Flare 2'] = 2,
    ['Flare 3'] = 3,
    ['Flare 4'] = 4,
    ['Flare 5'] = 5,
    ['Flare 6'] = 6,
    ['Flare 7'] = 7,
    ['Flare 8'] = 8,
    ['Flare 9'] = 9,
    ['Flare EX'] = 10,
    ['Floating+'] = 11,
    ['Flare EX+'] = 11,
}
for _,pn in pairs(PlayerNumber) do
    if W_PLAYER:IsEnabled(pn) and not GAMESTATE:IsDemonstration() then
        local opt = W_PLAYER:ReadPref(pn, 'GuageType', 'Normal')
        ff[pn] = (opt == 'Floating' or opt == 'Floating+')
        plLevel[pn] = mapFlareLevel[opt] or nil
        local course = GAMESTATE:GetCurrentCourse()
        if course and course:IsOni() or (GAMESTATE:IsExtraStage() or GAMESTATE:IsExtraStage2()) then
            -- 鬼モードの時は設定をいじらない
            -- TODO: Extra.crsを読み込んでいるときだけにする（EXFolder実装時に対応）
            flarePn[pn] = off
            plLevel[pn] = 0
        else
            -- 易化オプションを使用している場合はフレアを無効
            local poCur = GAMESTATE:GetPlayerState(pn):GetPlayerOptions('ModsLevel_Current')
            if (course and poCur:IsEasierForCourseAndTrail(GAMESTATE:GetCurrentCourse(), GAMESTATE:GetCurrentTrail(pn)))
                or (not course and poCur:IsEasierForSongAndSteps(W:Song(), W:Steps(pn), pn)) then
                plLevel[pn] = nil
            end
            -- ライフ設定を強制的に設定
            local po = GAMESTATE:GetPlayerState(pn):GetPlayerOptions('ModsLevel_Preferred')
            if plLevel[pn] then
                po:LifeSetting('LifeType_Bar')
                po:DrainSetting('DrainType_Normal')
            elseif string.sub(opt, 1, 4) == 'Life' then
                po:LifeSetting('LifeType_Battery')
                --po:BatteryLives(tonumber(split(' ', opt)[2]))
                GAMESTATE:ApplyPreferredModifiers(pn, string.format('mod,%d lives', split(' ', opt)[2]))
                flarePn[pn] = off
            elseif opt == 'Risky' then
                po:LifeSetting('LifeType_Battery')
                --po:BatteryLives(1)
                GAMESTATE:ApplyPreferredModifiers(pn, 'mod,1 life')
                flarePn[pn] = off
            elseif opt == 'NoRecover' then
                po:LifeSetting('LifeType_Bar')
                po:DrainSetting('DrainType_NoRecover')
                flarePn[pn] = off
                plLevel[pn] = 0
            elseif opt == 'SuddenDeath' then
                po:LifeSetting('LifeType_Bar')
                po:DrainSetting('DrainType_SuddenDeath')
                flarePn[pn] = off
                plLevel[pn] = 0
            else
                po:LifeSetting('LifeType_Bar')
                po:DrainSetting('DrainType_Normal')
                flarePn[pn] = off
                plLevel[pn] = 0
            end
        end
    end
end

local flare = (flarePn[PLAYER_1] ~= off or flarePn[PLAYER_2] ~= off)

W_LIFE:FlareMode(flare)
if not flare then
    return Def.Actor({})
end
local plLastlevel = {[PLAYER_1] = plLevel[PLAYER_1], [PLAYER_2] = plLevel[PLAYER_2]}

local flareSub = {
    {0,    10,   50,  150},
    {0,    11,   55,  300},
    {0,    12,   60,  450},
    {0,    29,  145, 1100},
    {0,    74,  370, 1600},
    {0,    92,  460, 1800},
    {0,   128,  640, 2200},
    {0,   164,  820, 2600},
    {0,   200, 1000, 3000},
    {100, 200, 1000, 3000},
    {500,2000, 5000,10000},
}
local flareColor = {
    '#0040ffff',
    '#00ffffff',
    '#57d335ff',
    '#ffff00ff',
    '#ff6c00ff',
    '#b400ffff',
    '#a08a30ff',
    '#b4b4c8ff',
    '#ff0080ff',
    'rainbow',
    '#000000ff',
}
local flareName = {'I','II','III','IV','V','VI','VII','VIII','IX','EX','EX+'}

local lifeSub = {}
local lifeCount = {}
local function GetLifeSub(plLevel)
    return {
        TapNoteScore_W2 = flareSub[plLevel][1],
        TapNoteScore_W3 = flareSub[plLevel][2],
        TapNoteScore_W4 = flareSub[plLevel][3],
        TapNoteScore_W5 = flareSub[plLevel][4],
        TapNoteScore_Miss = flareSub[plLevel][4],
        TapNoteScore_HitMine = flareSub[plLevel][4],
        HoldNoteScore_LetGo = flareSub[plLevel][4],
    }
end
for p,pn in pairs(PlayerNumber) do
    lifeSub[pn] = (flarePn[pn] == off) and {} or GetLifeSub(plLevel[pn])
    lifeCount[pn] = {
        TapNoteScore_W2 = 0,
        TapNoteScore_W3 = 0,
        TapNoteScore_W4 = 0,
        TapNoteScore_W5 = 0,
        TapNoteScore_Miss = 0,
        TapNoteScore_HitMine = 0,
        HoldNoteScore_LetGo = 0,
    }
end

return Def.ActorFrame({
    OnCommand = function(self)
        for p,pn in pairs(PlayerNumber) do
            if flarePn[pn] == off then
                pl[pn] = nil
            else
                pl[pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..p)
                if pl[pn] and plLevel[pn] then
                    --if plLevel[pn] == nil then lf[pn] = lf[pn]/2 end
                    --pl[pn]:SetLife(0.0001*lf[pn])
                    self:GetParent():playcommand('ChangedLifeType', {
                        Player = pn,
                        Level = plLevel[pn],
                        Color = plLevel[pn] and flareColor[plLevel[pn]] or nil,
                        Name = plLevel[pn] and 'FLARE - '..flareName[plLevel[pn]] or '',
                    })
                end
            end
        end
        self:SetUpdateFunction(function(self)
            for p,pn in pairs(PlayerNumber) do
                if pl[pn] and plLevel[pn] then
                    pl[pn]:SetLife(0.0001*lf[pn])
                end
            end
            setenv('WAIEI_FLARE_CUR_LIFE', {
                [PLAYER_1] = pl[PLAYER_1] and math.max(0.0001*lf[PLAYER_1], 0) or nil,
                [PLAYER_2] = pl[PLAYER_2] and math.max(0.0001*lf[PLAYER_2], 0) or nil,
            })
        end)
    end,
    OffCommand = function(self)
        setenv('WAIEI_FLARE_LEVEL', plLevel)
        setenv('WAIEI_FLARE_LAST', plLastlevel)
    end,
    JudgmentMessageCommand=function(self, params)
        if params.Player
            and (
                params.HoldNoteScore
                or (
                    params.TapNoteScore
                    and params.TapNoteScore ~= 'TapNoteScore_'   -- OFVのバグ体策
                )
            )
           then
            for p,pn in pairs(PlayerNumber) do
                if pn == params.Player and flarePn[pn] ~= off then
                    if plLevel[pn] and plLevel[pn] < 1 then return end
                    -- オートプレイをした瞬間記録は無効
                    if (GAMESTATE:GetPlayerState(pn):GetPlayerController() ~= 'PlayerController_Human') then
                        plLastlevel[pn] = 0
                        plLevel[pn] = 0
                        flarePn[pn] = off
                        pl[pn] = nil
                        self:GetParent():playcommand('ChangedLifeType', {
                            Player = pn,
                            Level = plLevel[pn],
                            Color = nil,
                            Name = '',
                        })
                        return
                    end
                    -- HoldNoteScoreのときもTapNoteScoreがあるのでHoldを優先して取得
                    local noteScore = params.HoldNoteScore or params.TapNoteScore
                    local sub = (lifeSub[pn][noteScore] or 0) + ((plLevel[pn] == nil and lf[pn] >= 10000 and lifeSub[pn][noteScore] > 0) and 1000 or 0)
                    if pl[pn] then
                        if lifeCount[pn][noteScore] then lifeCount[pn][noteScore] = lifeCount[pn][noteScore]+1 end
                        lf[pn] = lf[pn]-sub
                        if ff[pn] and lf[pn] <= 0 and plLevel[pn] and plLevel[pn] > 1 then
                            local sumSub = 0
                            if plLevel[pn] > 1 then
                                while plLevel[pn] > 1 do
                                    plLevel[pn] = plLevel[pn]-1
                                    if plLevel[pn] < 1 then break end
                                    lifeSub[pn] = GetLifeSub(plLevel[pn])
                                    sumSub = lifeCount[pn].TapNoteScore_W2*lifeSub[pn].TapNoteScore_W2
                                        +lifeCount[pn].TapNoteScore_W3*lifeSub[pn].TapNoteScore_W3
                                        +lifeCount[pn].TapNoteScore_W4*lifeSub[pn].TapNoteScore_W4
                                        +lifeCount[pn].TapNoteScore_W5*lifeSub[pn].TapNoteScore_W5
                                        +lifeCount[pn].TapNoteScore_Miss*lifeSub[pn].TapNoteScore_Miss
                                        +lifeCount[pn].TapNoteScore_HitMine*lifeSub[pn].TapNoteScore_HitMine
                                        +lifeCount[pn].HoldNoteScore_LetGo*lifeSub[pn].HoldNoteScore_LetGo
                                    if sumSub < 10000 then break end
                                end
                                plLastlevel[pn] = plLevel[pn]
                                self:GetParent():playcommand('ChangedLifeType', {
                                    Player = pn,
                                    Level = plLevel[pn],
                                    Color = plLevel[pn] and flareColor[plLevel[pn]] or nil,
                                    Name = plLevel[pn] and 'FLARE - '..flareName[plLevel[pn]] or '',
                                })
                            end
                            if plLevel[pn] < 1 then
                                lf[pn] = -1
                            else
                                lf[pn] = 10000 - sumSub
                            end
                        end
                        if lf[pn] <= 0 then
                            pl[pn]:SetLife(0)
                        elseif lf[pn] == 0 then
                            pl[pn]:SetLife(0.0001)
                        else
                            pl[pn]:SetLife(0.0001 * lf[pn])
                        end
                    end
                end
            end
        end
    end,
})